#include "stdafx.h"
#include "rscls.h"

/*------------------------------------------------------------------------------------

						VAʐMǗNX

-------------------------------------------------------------------------------------*/

//--- RXgN^ ---
rscls::rscls()
{
	BaudRate = CBR_9600;
	RxBuffSize = 1024L;
	TxBuffSize = 1024L;
}
//--- fBXgN^ ---
rscls::~rscls()
{
	if(hport != INVALID_HANDLE_VALUE)
		ClosePort();
}

//--- G[\֐ ---
void rscls::error(CString errorMessage)
{
	char ssc[1024];
	errorMessage += '\n';
	wsprintf(ssc,errorMessage);
	puts(ssc);
	exit(1);
}

//--- |[gJ -----------------------------
int rscls::OpenPortEz()
{
	int i;
	CString name;
	for(i=0; i<10; i++){
		name.Format("COM%d",i);
		if( OpenPort(name,0) != INVALID_HANDLE_VALUE )
			return 0;
	}
	return -1;
}

HANDLE rscls::OpenPort(char *portName, DWORD dwEvtMask)
{
	HANDLE handle;
	if( (handle=OpenPort(portName, dwEvtMask)) == INVALID_HANDLE_VALUE )
		return INVALID_HANDLE_VALUE;
	return handle;
}

HANDLE rscls::OpenPort(CString portName, DWORD dwEvtMask)
{
	//--- |[gJ ---
	hport = CreateFile(
		portName,
		GENERIC_READ | GENERIC_WRITE,
		0,
		NULL,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,
		NULL);

	if(hport == INVALID_HANDLE_VALUE)
		return INVALID_HANDLE_VALUE;

	//--- Cxg}XNݒ ---
	if(!SetCommMask(hport,dwEvtMask)){
		CloseHandle(hport);
		error("rsclsNXFCxg}XNݒɂăG[܂");
	}
	//--- obt@TCYݒ ---
	if(!SetupComm(hport,RxBuffSize,TxBuffSize)){
		CloseHandle(hport);
		error("rsclsNXFobt@TCYݒɂăG[܂");
	}

	//--- ^C}[ݒFM҂AM҂100ms + P10ms ---
	COMMTIMEOUTS CommTimeout;
	CommTimeout.ReadIntervalTimeout = 0;
	CommTimeout.ReadTotalTimeoutMultiplier = 0;
	CommTimeout.ReadTotalTimeoutConstant = 0;
	CommTimeout.WriteTotalTimeoutMultiplier = 10;
	CommTimeout.WriteTotalTimeoutConstant = 100;

	if(!SetCommTimeouts(hport,&CommTimeout)){
		CloseHandle(hport);
		error("rsclsNXF^CAEg\̐ݒɂăG[܂");
		return INVALID_HANDLE_VALUE;
	}

	//--- ʐMݒ115200BPS,8BIT,peBȂ,StopBit1 ---
	GetCommState(hport,&dcb);
	dcb.BaudRate = BaudRate;
	dcb.ByteSize = 8;
	dcb.Parity = NOPARITY;
	dcb.StopBits = ONESTOPBIT;
	SetCommState(hport,&dcb);

	if(!SetCommState(hport, &dcb)){
		CloseHandle(hport);
		error("rsclsNXFʐMݒɂăG[܂");
		return INVALID_HANDLE_VALUE;
	}
	return hport;
}

//--- |[g ---
void rscls::ClosePort(){ CloseHandle(hport); }

//--- f[^𑗐M ---
void rscls::TxD(CString sendMessage){ WriteFile(hport,sendMessage,sendMessage.GetLength(),&byteNum,NULL); }
void rscls::TxD(char *buff, int num){ WriteFile(hport,buff,num,&byteNum,NULL); }
void rscls::TxD(unsigned char *buff, int num){ WriteFile(hport,buff,num,&byteNum,NULL); }

//--- f[^M ---
void rscls::RxDbyte(unsigned char *buff)
{
	unsigned long readSize = GetReadSize();
	if(readSize){
		ReadFile(hport,buff,readSize,&byteNum,NULL);
	}
}
CString rscls::RxDstring()
{
	CString readString;
	unsigned long readSize = GetReadSize();
	if(readSize){
		ReadFile(hport,readString.GetBuffer(readSize),readSize,&byteNum,NULL);
		readString.ReleaseBuffer();
	}
	return readString;
}
double rscls::RxDtwobyte()
{
	char buff[1024];
	RxDbyte((unsigned char*)buff);
	return (double)strtoul(buff,NULL,16);
}

//--- MoCg𒲂ׂ ---
unsigned long rscls::GetReadSize()
{
	COMSTAT comStat;
	DWORD errorFlag;

	ClearCommError(hport, &errorFlag, &comStat);
	return comStat.cbInQue;
}

//--- obt@NA ---
void rscls::ClearBuff()
{
	PurgeComm(hport, PURGE_TXCLEAR); // Mobt@̃NA
    PurgeComm(hport, PURGE_RXCLEAR); // Mobt@̃NA
}


/*------------------------------------------------------------------------------------

							v`{NX

-------------------------------------------------------------------------------------*/

PuchiRobocls::PuchiRobocls()
{
	BaudRate = CBR_4800;
	ZeroMemory(m_GOALRELPOSITION,9*sizeof(int));
	ZeroMemory(m_NOWRELPOSITION,9*sizeof(int));
	ZeroMemory(SendAll,36*sizeof(char));
}



//T[{ԍƖڕWʒuw肵ē֐
void PuchiRobocls::Puchi_ServoMove(int ServoNum,int RelPosition)
{
	int AbsPosition;
	char SendStr[4];

	if(ServoNum<0 || ServoNum>8) return;

	//ΈʒuΈʒuւ̕ϊ
	AbsPosition=m_HOMEPOSITION[ServoNum]+m_DIRECTION[ServoNum]*RelPosition;
	if(AbsPosition<1) AbsPosition=1;
	if(AbsPosition>220) AbsPosition=220;
	//Rg[{[hւ̃R}h̍쐬
	SendStr[0]=(char)253; //wb_
	SendStr[1]=220+ServoNum+1; //T[{ԍ
	SendStr[2]=AbsPosition; //T[{ʒu
	SendStr[3]=AbsPosition+ServoNum+1; //peBH
	//R}h̑M
	TxD(SendStr,4);
}

//ׂẴT[{̖ڕWʒuzƌ݈ʒuzƃT[{Xs[hw肵ē֐
void PuchiRobocls::Puchi_ServoMoveAll(int ServoSpeed,int NowRelPosition[],int GoalRelPosition[])
{
	int flag=0;
	int i,AbsPosition;
	int derection[9]={0};

	for(i=0;i<9;i++) {
		if(GoalRelPosition[i]-NowRelPosition[i]>0) derection[i]=1;
		if(GoalRelPosition[i]-NowRelPosition[i]<0) derection[i]=-1;
		if(GoalRelPosition[i]-NowRelPosition[i]==0) derection[i]=0;
	}

	//ׂẴT[{ڕWʒuɓB܂ŌJԂ
	while(flag!=9) {
		flag=0;
		printf("\rServoMove:");////////////////////////////////
		for(i=0;i<9;i++) {
			//eT[{݈̌ʒu+Xs[hlĎ̎Ԃ̈ʒu
			switch(derection[i]) {
			case 1 :
				NowRelPosition[i]+=ServoSpeed;
				if(GoalRelPosition[i]<=NowRelPosition[i]) {
					NowRelPosition[i]=GoalRelPosition[i];
					derection[i]=0;
					flag++;
				}
				break;
			case -1 :
				NowRelPosition[i]-=ServoSpeed;
				if(GoalRelPosition[i]>=NowRelPosition[i]) {
					NowRelPosition[i]=GoalRelPosition[i];
					derection[i]=0;
					flag++;
				}
				break;
			case 0 :
				flag++;
				break;
			default :
				break;
			}
			//ΈʒuΈʒu֕ϊ
			AbsPosition=m_HOMEPOSITION[i]+m_DIRECTION[i]*NowRelPosition[i];
			if(AbsPosition<1) AbsPosition=1;
			if(AbsPosition>220) AbsPosition=220;
			//Rg[{[hւ̃R}h쐬
			SendAll[i*4]=(char)253; //wb_
			SendAll[i*4+1]=220+i+1; //T[{ԍ
			SendAll[i*4+2]=AbsPosition; //T[{ʒu
			SendAll[i*4+3]=AbsPosition+i+1; //peBH

			printf("%1d%+04d,",i,NowRelPosition[i]);////////////////////////////////////////////////
		}
		//R}h̑M
		TxD(SendAll,36);///////////////////////////////////////////
		Sleep(10);
	}
	printf("\n");////////////////////////////////////////////////////////////
}

//[Vt@C̃t@Cw肵ăv`{𓮂֐
void PuchiRobocls::Puchi_Motion(char FileName[])
{
	char comment[128],chr;
	FILE *fp;
	int ServoNum,RelPosition,WaitTime,ServoSpeed;
	int GoalRelPosition[9]={0};

	fp=fopen(FileName,"r");
	chr=getc(fp);
	//R}h̓[`
	while(chr!=EOF) {
		switch(chr) {
		case ';' ://Rgs̉
			fscanf(fp,"%s",comment);
			printf("Comment:%s\n",comment);
			break;
		case 'S' ://Xs[hݒ̉
			fscanf(fp,"%d",&ServoSpeed);
			printf("Speed:%d\n",ServoSpeed);
			break;
		case 'W' ://҂Ԑݒ̉
			fscanf(fp,"%d",&WaitTime);
			printf("Wait:%d[ms]\n",WaitTime);
			Sleep(WaitTime);
			break;
		case '0' ://T[{ʒuws̉
			ServoNum=0;
			fscanf(fp,"%d",&RelPosition);
			GoalRelPosition[ServoNum]=RelPosition;
			chr=getc(fp);
			while(chr!='\n') {
				if(chr==',') {
					chr=getc(fp);
					ServoNum=atoi(&chr);
					fscanf(fp,"%d",&RelPosition);
					GoalRelPosition[ServoNum]=RelPosition;
				}
				chr=getc(fp);
			}
			//݈ʒuƃS[ʒuƃT[{Xs[hɂċ쓮֐
			Puchi_ServoMoveAll(ServoSpeed,m_NOWRELPOSITION,GoalRelPosition);
			Sleep(30);
			break;
		default :
			break;
		}
		chr=getc(fp);
	}
	fclose(fp);
}